<?php
class TWidget  {

	protected $view=null;
    public $templateFile="";
	protected $parameters=null;
	protected $name=null;
	protected $lifeCycle=array("init","run");
	private $widgetTemplateFolder="";

	public function __construct() {
		$this->view=new Smarty();

	}

	protected function create() {}
	protected function init() {}
	protected function run() {}

	public function output() {
        return $this->view->fetch(substr(strtolower(get_class($this)),1).".tpl");
	}

	public function execute($type,$params=array()) {
		$this->parameters=$params;
		$templateFolder=dirname(implode("/",explode(".",$type)));
		$this->templateFolder="widgets/".$templateFolder;
		$baseDir=Application::get("BASE_DIR");

		$templatesBaseDir=$_SERVER["DOCUMENT_ROOT"].$baseDir."/resources";
		$templatesCompileBaseDir=$_SERVER["DOCUMENT_ROOT"].$baseDir."/resources/".Application::get("TEMPLATE_C_DIR");
		$themeTemplateDir=$templatesBaseDir."/themes/".Application::Get("DEFAULT_THEME")."/templates".($this->templateFolder!=""?"/":"").$this->templateFolder;
		if (file_exists($themeTemplateDir))
			$templatesBaseDir.="/themes/".Application::Get("DEFAULT_THEME")."/templates".($this->templateFolder!=""?"/":"").$this->templateFolder;

		$templatesBaseDir=str_replace("//","/",$templatesBaseDir);
		$templatesCompileBaseDir=str_replace("//","/",$templatesCompileBaseDir);

		$this->view->compile_dir=$templatesCompileBaseDir;

        $this->view->setTemplateDir($templatesBaseDir);

	//	$parameters=Application::getWidgetParameters($name);
		$this->name=$params["name"];
//		$this->parameters=$parameters;
        try {
            if ($this->create()!==false) {
                foreach($this->lifeCycle as $method) {
                    if(call_user_func(array($this,$method))===false) {
                        break;
                    }
                }
            }
        } catch(ErrorException $e) {
            $this->view->assign("template","common/error.tpl");
            $this->view->assign("error",debug_backtrace());
        }
        return $this->output();
    }

	protected function set($vars) {
		foreach($vars as $key => $val) {
			$this->view->assign($key,$val);
		}
	}
}
